# Julia API client for Client

OPA provides policy-based control for cloud native environments.
The REST API is a very common way to integrate with OPA.
There are [18 OPA Ecosystem projects](https://www.openpolicyagent.org/ecosystem/rest-api-integration) - many
of which are open source - built on the REST API which might serve as inspiration. You may also want to
review the [integration documentation](https://www.openpolicyagent.org/docs/latest/integration) for other
options to build on OPA by embedding functionality directly into your application.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 0.57.0
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen
For more information, please visit [https://github.com/open-policy-agent/opa](https://github.com/open-policy-agent/opa)


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include Client.jl in the project code.
It would include the module named Client.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*CompileApi* | [**post_compile**](docs/CompileApi.md#post_compile)<br/>**POST** /v1/compile<br/>Partially evaluate a query.
*ConfigApi* | [**get_config**](docs/ConfigApi.md#get_config)<br/>**GET** /v1/config<br/>Get configurations
*DataApi* | [**create_document**](docs/DataApi.md#create_document)<br/>**PUT** /v1/data/{path}<br/>Create or overwrite a document.
*DataApi* | [**delete_document**](docs/DataApi.md#delete_document)<br/>**DELETE** /v1/data/{path}<br/>Delete a document
*DataApi* | [**get_document**](docs/DataApi.md#get_document)<br/>**GET** /v1/data/{path}<br/>Get a document
*DataApi* | [**get_document_from_webhook**](docs/DataApi.md#get_document_from_webhook)<br/>**POST** /v0/data/{path}<br/>Get a document from a webhook.
*DataApi* | [**get_document_with_path**](docs/DataApi.md#get_document_with_path)<br/>**POST** /v1/data/{path}<br/>Get a document that required an input
*DataApi* | [**patch_document**](docs/DataApi.md#patch_document)<br/>**PATCH** /v1/data/{path}<br/>Patch a document
*HealthApi* | [**get_health**](docs/HealthApi.md#get_health)<br/>**GET** /health<br/>Health
*PolicyApi* | [**delete_policy_module**](docs/PolicyApi.md#delete_policy_module)<br/>**DELETE** /v1/policies/{id}<br/>Delete a policy module
*PolicyApi* | [**get_policies**](docs/PolicyApi.md#get_policies)<br/>**GET** /v1/policies<br/>List policies
*PolicyApi* | [**get_policy_module**](docs/PolicyApi.md#get_policy_module)<br/>**GET** /v1/policies/{id}<br/>Get a policy module
*PolicyApi* | [**put_policy_module**](docs/PolicyApi.md#put_policy_module)<br/>**PUT** /v1/policies/{id}<br/>Create or update a policy module
*QueryApi* | [**query_get**](docs/QueryApi.md#query_get)<br/>**GET** /v1/query<br/>Execute an ad-hoc query and return bindings for variables found in the query.
*QueryApi* | [**query_post**](docs/QueryApi.md#query_post)<br/>**POST** /v1/query<br/>Execute an ad-hoc query and return bindings for variables found in the query.
*QueryApi* | [**simple_query**](docs/QueryApi.md#simple_query)<br/>**POST** /<br/>Execute a simple query.
*StatusApi* | [**get_status**](docs/StatusApi.md#get_status)<br/>**GET** /v1/status<br/>Get status


## Models

 - [CompileSuccessResponse](docs/CompileSuccessResponse.md)
 - [CreateDocumentSuccessResponse](docs/CreateDocumentSuccessResponse.md)
 - [DeleteDocumentSuccessResponse](docs/DeleteDocumentSuccessResponse.md)
 - [ErrorDetail](docs/ErrorDetail.md)
 - [ErrorLocation](docs/ErrorLocation.md)
 - [GetDocumentSuccessResponse](docs/GetDocumentSuccessResponse.md)
 - [GetPolicyListSuccessResponse](docs/GetPolicyListSuccessResponse.md)
 - [GetPolicyModuleSuccessResponse](docs/GetPolicyModuleSuccessResponse.md)
 - [PartialQuerySchema](docs/PartialQuerySchema.md)
 - [PatchOperation](docs/PatchOperation.md)
 - [Policy](docs/Policy.md)
 - [PolicyAst](docs/PolicyAst.md)
 - [PolicyAstPackage](docs/PolicyAstPackage.md)
 - [PolicyAstPackagePathInner](docs/PolicyAstPackagePathInner.md)
 - [PolicyAstRulesInner](docs/PolicyAstRulesInner.md)
 - [PolicyAstRulesInnerBodyInner](docs/PolicyAstRulesInnerBodyInner.md)
 - [PolicyAstRulesInnerHead](docs/PolicyAstRulesInnerHead.md)
 - [PolicyAstRulesInnerHeadKey](docs/PolicyAstRulesInnerHeadKey.md)
 - [Provenance](docs/Provenance.md)
 - [PutPolicySuccessResponse](docs/PutPolicySuccessResponse.md)
 - [QueryParameterPost](docs/QueryParameterPost.md)
 - [ServerErrorResponse](docs/ServerErrorResponse.md)
 - [UnhealthyResponse](docs/UnhealthyResponse.md)


<a id="authorization"></a>
## Authorization
Endpoints do not require authorization.


## Author



